
;****************************************************
;
;******************* TAIL LIGHTS RECEIVER *****************
;
;
;****************************************************
  

;03/23/2010
;XTAL 4 MHz
;USE RS232 2400 BAUD 
;LIGHTS ON BSF

;PIN 1 VCC
;PIN 2 RB5 	  TAILLIGHTS   
;PIN 3 RB4    BRAKE EITHER RIGHT OR LEFT                  
;PIN 4 RB3    NC
;PIN 5 RB2    NC     
;PIN 6 RB1	  NC
;PIN 7 RB0	  SERIAL IN DATA STREAM
;PIN 8 VSS
	RADIX		HEX	;HEX IS DEFAULT # FORMAT
    list      p=12F508            ; list directive to define processor
    #include <p12F508.inc>        ; processor specific variable definitions

    __CONFIG   _MCLRE_OFF & _CP_OFF & _WDT_OFF & _IntRC_OSC
 
TEMP           	EQU		07H		  	;WORKING REGISTER
DELAY_CNTR     	EQU     08H       	;COUNTING REGISTER FOR RS232
BIT_CNTR1     	EQU     09H       	;COUNTING REGISTER FOR RS232
BIT_CNTR       	EQU     0AH       	;COUNTING REGISTER FOR RS232
RCV_BYTE       	EQU     0BH       	;TRANSFER REGISTER FOR RS232
RCV_BYTE1      	EQU     0CH       	;TRANSFER REGISTER FOR RS232
KEY1		   	EQU		0DH			;KEY 1 FOR RECEIVER
KEY2			EQU		0EH			;KEY 2 FOR RECEIVER
KEY1TRANS		EQU		0FH			;RECEIVED KEY 1 FROM TRANSMITTER
KEY2TRANS		EQU		10H			;RECEIVED KEY 1 FROM TRANSMITTER
FLAGS			EQU		11H			;FLAG REGISTER
COUNT			EQU		12H			;COUNTING REGISTER
COUNT1			EQU		13H			;COUNTING REGISTER
COUNT2			EQU		14H			;COUNTING REGISTER
COUNT3			EQU		015H		;COUNTING REGISTER
COUNT4			EQU		016H		;COUNTING REGISTER
COUNT5			EQU		017H		;COUNTING REGISTER

#DEFINE		   SERIAL_IN    GPIO,1     	;RS232 TRANSMIT DATA
#DEFINE		   LIGHTS		GPIO,5		;DRIVER FOR LIGHTS
#DEFINE		   BRAKE		GPIO,4		;DRIVER FOR BRAKE
#DEFINE		   FLAG			FLAGS,0		;FLAG FOR MODE
#DEFINE		   BLINK		GPIO,2		;OUTPUT FOR POWER LED
		ORG	00H

MAIN    	MOVWF   	OSCCAL            ; update register with factory cal value 

;********INPUT KEY 1 IN HEXIDECIMAL E.G.0A1H
			MOVLW		B'10101010'	;LOADING KEY 1
			MOVWF		KEY1		;LOAD
;********INPUT LAST 4 BITS KEY 2 IN HEXIDECIMAL E.G., 0A0H  (ZERO MUST PRECEED ANY LETTER)
			MOVLW		0F8H		;LOADING KEY 2
 		    MOVWF		KEY2		;LOAD
;***************RIGHT OR LEFT TAILLIGHT*******************
;FOR RIGHT TAILLIGHT LOAD MODE WITH 0
;FOR LEFT TAILLIGHT LOAD MODE WITH 1
#DEFINE		MODE 	1

	IF MODE == 0
	BCF		FLAG					;CLEAR FLAG
	ELSE
	BSF		FLAG					;SET FLAG
	ENDIF

AWAYWEGO							;LABLE
      	  	CLRF		GPIO		;CLEAR PINS
		  	MOVLW		B'001011'	;LOAD PINS FOR IN AND OUT  
		  	TRIS		GPIO		;LOAD
			MOVLW		B'10011111'	;LOADING OPTION REGISTER
			OPTION					;LOAD
			MOVLW		.6			;LOADING COUNT 2
			MOVWF		COUNT2		;LOAD
			MOVLW		.80			;LOADING COUNT 5		
			MOVWF		COUNT5		;LOAD


	
START	BSF			BLINK			;TURN ON POWER INDICATOR
		DECFSZ		COUNT,1			;ONE SECOND DELAY SYSTEM
		GOTO		START			;ONE SECOND DELAY SYSTEM
		DECFSZ		COUNT1,1		;ONE SECOND DELAY SYSTEM
		GOTO		START			;ONE SECOND DELAY SYSTEM
		DECFSZ		COUNT2,1		;ONE SECOND DELAY SYSTEM
		GOTO		START			;ONE SECOND DELAY SYSTEM
		BSF			BLINK			;FLASH LED SHOWING POWER ON
		BCF			BLINK			;TURN OFF POWER INDICATOR
		MOVLW		.6				;ONE SECOND DELAY SYSTEM
		MOVWF		COUNT2			;RELOAD COUNT 2



CHECK   CLRF		COUNT3			;RESETTING COUNT 3
		MOVLW		.7				;RESETTING COUNT 4
		MOVWF		COUNT4			;LOAD
 		DECFSZ		COUNT,1			;DECREASE COUNT
		GOTO		C2				;TIMER
		BCF			BRAKE 			;TURN OFF BRAKE TIMER TIMED OUT FOR BRAKE
		DECFSZ		COUNT1,1		;TIMER
		GOTO		C2				;TIMER
		DECFSZ		COUNT5,1		;TIMER
		GOTO		C2				;GO TO C2
		MOVLW		.80				;RESET COUNT 5
		MOVWF		COUNT5			;LOAD
		BCF			LIGHTS			;TURN OFF LIGHTS TIMER TIMED OUT FOR LIGHTS
	
		
C2	    BTFSS		SERIAL_IN		;MAKE SURE SERIAL IN IS HIGH FOR A PERIOD OF TIME INDICATING TRANSMITER SIGNAL
		GOTO		CHECK			;NOT HIGH GO TO CHECK
		DECFSZ		COUNT3,1		;TIMING FOR TRANSMITTER ON
		GOTO		C2				;TIMER
		DECFSZ		COUNT4,1		;TIMER	
		GOTO		C2				;TIMER
		CLRF		COUNT1			;RESET COUNT 1
		MOVLW		.80				;RESET COUNT 5
		MOVWF		COUNT5			;LOAD
	  	BTFSC		SERIAL_IN		;CHECK FOR DATA SIGNAL FROM TRANSMITTER
		GOTO		$-1				;NO DATA
C1		CALL		START_DELAY		;DATE CHECKING TO SEE IF VALID
		BTFSC		SERIAL_IN		;STILL LOW?
		GOTO		CHECK			;NO GO BACK TO CHECK
		MOVLW		.8				;LOAD BIT COUNTER
		MOVWF		BIT_CNTR		;LOAD
		CLRF		RCV_BYTE		;CLEAR RCV BYTE
NEXT_RCVBIT							;LABEL
		CALL		BIT_DELAY		;CALLING BIT DELAY
		BTFSS		SERIAL_IN		;IS DATA IN HIGH?
		BCF			STATUS,C		;NO CLEAR STATUS C
		BTFSC		SERIAL_IN		;IS DATE LOW?
		BSF			STATUS,C		;NO SET STATUS C
		RRF			RCV_BYTE,1		;ROTATE RECEIVE BYTE OUT
		DECFSZ		BIT_CNTR,1		;CHECK TO SEE IF 8 BIT SENT
		GOTO		NEXT_RCVBIT		;NOT 8 DO AGAIN

NB		MOVF		RCV_BYTE,W		;DONE MOVE RECEIVE BYTE INTO KEY1TRANS
		MOVWF		KEY1TRANS		;LOAD
		MOVLW		.8				;RESET BIT COUNTER
		MOVWF		BIT_CNTR		;LOAD
		CLRF		RCV_BYTE1		;CLEAR RECEIVE BYTE 1

NEXT_RCVBIT1						;LABEL
		CALL		BIT_DELAY		;CALL BIT DELAY
		BTFSS		SERIAL_IN		;CHECK SERIAL IN
		BCF			STATUS,C		;LOW CLEAR STATUS C
		BTFSC		SERIAL_IN		;CHECK SERIAL IN
		BSF			STATUS,C		;HIGH SET STATUS C
		RRF			RCV_BYTE1,1		;ROTATE BIT OUT
		DECFSZ		BIT_CNTR,1		;CHECK FOR 8 BITS
		GOTO		NEXT_RCVBIT1	;NOT 8 BITS DO AGAIN
		CALL		BIT_DELAY		;CALL BIT DELAY
		MOVF		RCV_BYTE1,W		;MOVING RECEIVE BYTE INTO KEY2TRANS
		MOVWF		KEY2TRANS		;LOAD
		GOTO		DECODE			;GO TO DECODE
      
;********************RS232 INSTRUCTIONS***********
       
BIT_DELAY 
		MOVLW		D'200'		    ;SETUP FOR 1200 BAUD
		MOVWF		DELAY_CNTR      ;DELAY LOOP
LOOP_1  NOP							;DELAY HELP
		DECFSZ  	DELAY_CNTR,1	;DECREASING COUNTER		
		GOTO		LOOP_1    		;DECREASE COUNTER
		RETLW 	    0               ;RETURN TO CALL

START_DELAY							;LABEL
		MOVLW		D'100'		   	;SETUP FOR 1200 BAUD SETS FOR DETECTING MIDDLE OF BIT
		MOVWF		DELAY_CNTR	   	;DELAY LOOP
		
LOOP_2	NOP							;DELAY HELP
		DECFSZ		DELAY_CNTR,1	;DECREASEING COUNTER
	    GOTO		LOOP_2          ;DECREASE COUNTER
        RETLW 		0              	;RETURN TO CALL
 
DECODE								;LABEL
;*****************CHECKING KEY ONE***************
		MOVF		KEY1,0			;MOVE KEY1 INTO W
		SUBWF		KEY1TRANS,0		;SUBTRACT TRANSMITTED KEY
		BTFSC		3,2				;CHECK TO SEE IF IDENTICAL
		GOTO		D1				;IDENTICAL GO TO D1
		GOTO		CHECK			;DID NOT MATCH START OVER

;**************ELIMINATEING KEY TWO FIRST 3 BITS ***************
D1		MOVF		KEY2TRANS,0		;MAKE A DUPLICATE OF KEY 2 TRANSMISSION	
		MOVWF		TEMP			;LOAD INTO TEMP

		MOVLW		B'11111000'		;GETTING RID OF FIRST 3 DIGITS OF KEY 2
		ANDWF		KEY2,1			;GETTING RID OF FIRST 3 DIGITS OF KEY 2
		MOVLW		B'11111000'		;GETTING RID OF FIRST 3 DIGITS OF TEMP
		ANDWF		TEMP,1			;GETTING RID OF FIRST 3 DIGITS OF TEMP

;****************CHECKING KEY TWO****************
		MOVF		KEY2,0			;MOVE KEY2 INTO W
		SUBWF		TEMP,0			;SUBTRACT TRANSMITTED KEY DUPLICATE
		BTFSC		3,2				;CHECK TO SEE IF IDENTICAL
		GOTO		D2				;IDENTICAL GOT TO D2
		GOTO		CHECK			;NOT IDENTICAL START OVER

;**********************CHECKING BITS*************
D2	 	BTFSC		KEY2TRANS,2		;CHECK BIT TWO OF TRANSMITTED KEY2
		GOTO		D3				;SET GO TO TO D3
	  	BCF			LIGHTS			;NOT SET TURN OFF LIGHTS
		GOTO		BRAKES			;JUMP TO BRAKES
D3	    BSF			LIGHTS			;TURN 0N TAIL LIGHTS

;************* BRAKE AREA *****************
BRAKES 
		BTFSC		FLAG			;CHECKING MODE FOR LEFT OR RIGHT
		GOTO		LEFT		

;*****************RIGHT BRAKE ***********************
RIGHT	BTFSC		KEY2TRANS,0		;CHECK BIT 0 OF TRANSMITTED KEY2
		GOTO		D4				;SET GO TO D4
		BCF			BRAKE			;NOT SET TURN OFF
		GOTO		CHECK			;START ALL OVER
D4	    BSF			BRAKE			;SET TURN ON BRAKE LIGHTS
		GOTO		CHECK			;START ALL OVER


;***************LEFT BRAKE AREA***************
LEFT	BTFSC		KEY2TRANS,1		;CHECK BIT 1 OF TRANSMITTED KEY 2
		GOTO		D5				;SET GOTO D4
		BCF			BRAKE			;NOT SET TURN OFF
		GOTO		CHECK			;START ALL OVER
D5		BSF			BRAKE			;SET TURN ON LIGHTS
		GOTO		CHECK			;START ALL OVER


		END			;END OF PROGRAM