 
;****************************************************
;
;******************* TAIL LIGHTS TRANSMITTER *****************
;
;
;****************************************************
  

;03/23/2010
;XTAL 4 MHz
;USE RS232 2400 BAUD 

;PIN 1 VCC
;PIN 2 RB5 	  TAILLIGHT   
;PIN 3 RB4    LEFT                  
;PIN 4 RB3    RIGHT
;PIN 5 RB2    PDN     
;PIN 6 RB1	  NC
;PIN 7 RB0	  TRANSMIT RS232
;PIN 8 VSS
	RADIX		HEX	;HEX IS DEFAULT # FORMAT
    list      p=12F508            ; list directive to define processor
    #include <p12F508.inc>        ; processor specific variable definitions

    __CONFIG   _MCLRE_OFF & _CP_OFF & _WDT_OFF & _IntRC_OSC
 
DELAY_CNTR     	EQU		07H		  ;COUNTING REGISTER FOR RS232
BIT_CNTR       	EQU     08H       ;COUNTING REGISTER FOR RS232
BIT_CNTR1     	EQU     09H       ;COUNTING REGISTER FOR RS232
XMT_BYTE       	EQU     0AH       ;COUNTING REGISTER FOR RS232
XMT_BYTE1      	EQU     0BH       ;TRANSFER REGISTER FOR RS232
KEY1      		EQU     0CH       ;KEY 1 FOR RECEIVER
KEY2			EQU	   	0DH		  ;KEY 2 FOR RECEIVER
FLAGS			EQU		0EH		  ;GENERAL FLAG REGISTER
COUNTER			EQU		0FH		  ;COUNTING REGISTER
COUNTER1		EQU		010H
COUNTER2		EQU		011H
COUNTER3		EQU		012H
COUNTER4		EQU		013H
COUNTER5		EQU		014H
#DEFINE		   SERIAL_OUT   GPIO,0     	;RS232 TRANSMIT
#DEFINE		   RIGHT		GPIO,3		;RIGHT TURN SIGNAL
#DEFINE		   LEFT			GPIO,4		;LEFT TURN SIGNAL
#DEFINE		   LIGHTS		GPIO,5		;TAIL LIGHTS
#DEFINE		   PDN			GPIO,1		;ACTIVATION OF TRANSMITTER
#DEFINE		   LIGHT_FLAG	FLAGS,0		;FLAG FOR CHECK IF LIGHTS ARE ON
#DEFINE		   FLAG1		FLAGS,1		;FLAG ONE
#DEFINE		   FLAG2		FLAGS,2		;FLAG TWO
		ORG	00H

			CLRF	GPIO				;CLEAR ALL PINS

MAIN    	MOVWF   	OSCCAL            ; update register with factory cal value 

;********INPUT KEY 1 IN HEXIDECIMAL E.G.0A1H
			MOVLW		B'10101010'		;INPUT KEY NUMBER HERE
			MOVWF		KEY1		;LOAD

;********INPUT LAST 5 BITS KEY 2 IN HEXIDECIMAL E.G., 0A0H  (ZERO MUST PRECEED ANY LETTER)
			MOVLW		0F8H		;INPUT KEY NUMBER HERE (0A8H) OR (AOH)  FIRST THREE BITS IGNORED
 		    MOVWF		KEY2		;LOAD

AWAYWEGO
			MOVLW		B'11000000'	;INPUT FOR OPTION
			OPTION  				;LOAD OPTION
    	  	CLRF		GPIO		;CLEARING OUTPUT
		  	MOVLW		B'00111000'	;LOADING FOR IN AND OUT OF PINS  GP0, GP2 OUT
		  	TRIS		GPIO		;LOAD
			CLRF		FLAGS		;CLEAR FLAGS
			MOVLW		.5			;SETTING COUNTER2
			MOVWF		COUNTER2	;LOAD
			MOVLW		.10			;SETTING COUNTER3 & 4
			MOVWF		COUNTER3	;LOAD
			MOVWF		COUNTER4	;LOAD


;************HEAD LIGHTS****************
START	
			BTFSC	LIGHTS			;CHECK IF HEAD LIGHTS ARE ON	
			GOTO	S0				;ON GOTO SO
			BCF		KEY2,2			;OFF MAKE KEY2 LOW
			BCF		LIGHT_FLAG		;MAKE LIGHT FLAG LOW
			BCF		FLAG2			;MAKE FLAG 2 LOW
			GOTO	S1				;GOTO S1
S0			BSF		KEY2,2			;ON MAKE KEY 2 HIGH
			BSF		LIGHT_FLAG		;MAKE LIGHT FLAG HIGH
			GOTO	S1				;GOTO S1
    
;**********LEFT TURN LIGHT**************
S1		  	BTFSC	LEFT			;CHECK FOR LEFT TURN OR BRAKE
			GOTO	S2				;NOT ON SKIP
			BCF		KEY2,1			;NOT ON CLEAR BIT 1
			BCF		FLAG1			;CLEAR FLAG 1
			GOTO	S3				;JUMP TO NEXT LIGHT
S2		    BSF		KEY2,1			;ON SET BIT 1
			BSF		FLAG1			;SET FLAG 1

;**********RIGHT TURN LIGHT************
S3			BTFSC	RIGHT			;CHECK FOR RIGHT TURN OR BRAKE
			GOTO	S4				;NOT ON SKIP
			BCF		KEY2,0			;NOT ON CLEAR BIT 0
			BTFSS	FLAG1			;CHECK FLAG 1
			BCF		FLAG1			;FLAG 1 LOW
			GOTO	KEY				;JUMP TO KEY LABEL
S4			BSF		KEY2,0			;ON SET BIT 0
			BSF		FLAG1			;SET FLAG 1

KEY			BTFSS	FLAG1			;CHECK FLAG 1
			GOTO	TIMER			;NOT SET GO TO TIMER
			MOVF	KEY1,0			;LOAD KEY1 INTO TRANSMIT BYTE
			MOVWF	XMT_BYTE		;LOAD
			MOVF	KEY2,0			;LOAD KEY2 INTO TRANSMIT BYTE 1
	    	MOVWF	XMT_BYTE1		;LOAD
			CALL 	SEND			;CALL SEND
			GOTO	START			;DONE DO AGAIN

TIMER		BTFSS	LIGHT_FLAG		;CHECK LIGHT FLAG
			GOTO	START			;NOT SET GO BACK TO START
			BTFSS	FLAG2			;SET CHECK FLAG2 WHICH CHECKS FOR FIRST TIME TO TURN ON IMMEDIATELY
			GOTO	T0				;NOT SET GO TO T0
			GOTO	T1				;SET GO TO T1
T0			BSF		FLAG2			;SET FLAG 2 CAUSE TIMER TO START ON SECOND PASS
			BSF		KEY2,2
			GOTO	S9				;GO TO S9
T1			BCF		PDN				;TURN OFF POWER TO TRANSMITTER
			BTFSC	LIGHTS			;CHECK IF LIGHTS ARE ON
			GOTO	T2				;ON GO TO T2
			BCF		KEY2,2			;TURN OFF TAIL LIGHTS
			GOTO	S9				;GO TO S9
;**********LEFT TURN LIGHT**************
T2		  	BTFSC	LEFT			;CHECK FOR LEFT TURN
			GOTO	S5				;NOT ON SKIP
			BCF		KEY2,1			;NOT ON CLEAR BIT 1
			BCF		FLAG1			;CLEAR FLAG 1
			GOTO	S6				;JUMP TO NEXT LIGHT
S5		    BSF		KEY2,1			;ON SET BIT 1
			BSF		FLAG1			;SET FLAG 1

;**********RIGHT TURN LIGHT************
S6			BTFSC	RIGHT			;CHECK FOR RIGHT TURN
			GOTO	S7				;NOT ON SKIP
			BCF		KEY2,0			;NOT ON CLEAR BIT 0
			BTFSS	FLAG1			;CHECK FLAG 1
			BCF		FLAG1			;FLAG 1 LOW CLEAR FLAG 1
			GOTO	KEYA			;JUMP TO KEY LABEL
S7			BSF		KEY2,0			;ON SET BIT 0
			BSF		FLAG1			;SET FLAG 1

KEYA		BTFSS	FLAG1			;CHECK FLAG 1
			GOTO	S8				;FLAG 1 LOW GO TO S8
			MOVF	KEY1,0			;LOAD KEY 1 INTO TRANSMIT BYTE
			MOVWF	XMT_BYTE		;LOAD
			MOVF	KEY2,0			;LOAD KEY 2 INTO TRANSMIT BYTE 1
	    	MOVWF	XMT_BYTE1		;LOAD
			CALL 	SEND			;CALL SEND
			GOTO	START			;DONE DO AGAIN
S8			DECFSZ	COUNTER,1		;TIMING LOOP
			GOTO	T1				;TIMING LOOP
			DECFSZ	COUNTER1,1		;TIMING LOOP
			GOTO	T1				;TIMING LOOP
			DECFSZ	COUNTER2,1		;TIMING LOOP
			GOTO	T1				;TIMING LOOP
			MOVLW	.5				;RESET COUNTER 2
			MOVWF	COUNTER2		;LOAD
S9			BSF		PDN				;TURN ON TRANSMITTER
			MOVLW	D'20'			;LOAD COUNTER
			MOVWF	COUNTER5		;LOAD
			MOVF	KEY1,0			;LOAD KEY1 INTO TRANSMIT BYTE
			MOVWF	XMT_BYTE		;LOAD
			MOVF	KEY2,0			;LOAD KEY2 INTO TRANSMIT BYTE 1
	    	MOVWF	XMT_BYTE1		;LOAD
			CALL	SEND			;CALL SEND
			DECFSZ	COUNTER5,1		;SEND 50 TIMES
			GOTO	$-2				;SEND 50 TIMES
			GOTO	START			;START OVER

;********************RS232 INSTRUCTIONS***********
       
BIT_DELAY 
		MOVLW	D'200'			   	;GENERATING 2400 BAUD DELAY
		MOVWF	DELAY_CNTR         	;LOAD INTO COUNTER
		
LOOP    NOP						   	;TIMEING HELPER
	    DECFSZ	DELAY_CNTR,1			;DECREMENT TIMER
		GOTO	LOOP		       	;DECREASE COUNTER
        RETLW   0                   ;RETURN TO CALL 

SEND    BSF		PDN					;TURN ON TRANSMITTER
		DECFSZ	COUNTER,1			;TIMER FOR POWER UP DELAY
		GOTO	SEND				;TIMER PROGRAM
		DECFSZ	COUNTER3,1			;TIMER PROGRAM
		GOTO	SEND				;TIMER PROGRAM
		MOVLW	.10					;RESET TIMER
		MOVWF	COUNTER3			;LOAD

    	MOVLW	D'8'			   ;LOAD 8 INTO W EIGHT BITS IN A BYTE
	    MOVWF	BIT_CNTR           ;LOAD
	    MOVLW	D'8'			   ;LOAD 8 INTO W EIGHT BITS IN A BYTE
	    MOVWF	BIT_CNTR1		   ;LOAD
	    BCF	    SERIAL_OUT		   ;BRING SERIAL OUT LOW
        CALL    BIT_DELAY          ;START BIT SERIAL LOW FOR 2400 BAUD

XMIT    RRF     XMT_BYTE,1         ;ROTATE XMT BYTE FOR NEXT BIT
	    BTFSS	3,0				   ;CHECK TO SEE BIT SET
	    BCF		SERIAL_OUT		   ;NOT SET BRING SERIAL OUT LOW
	    BTFSC	3,0				   ;CHECK TO SEE IF SET	
	    BSF		SERIAL_OUT		   ;BIT SET MAKD SERIAL OUT HIGH
        CALL    BIT_DELAY          ;DATA BIT DELAY FOR 2400 BAUD
        DECFSZ 	BIT_CNTR,1		   ;CHECK TO SEE IT 8 BITS HAVE BEEN SENT
        GOTO	XMIT               ;DO UNITL EIGHT BITS ARE SENT

;********************SECOND BYTE BEING SENT.  TOTAL 2 BYTES 16 BITS
XMIT1	RRF     XMT_BYTE1,1         ;ROTATE XMT BYTE FOR NEXT BIT
	    BTFSS	3,0					;CHECK TO SEE BIT SET
	    BCF		SERIAL_OUT			;NOT SET BRING SERIAL OUT LOW
	    BTFSC	3,0  				;CHECK TO SEE IF SET	
	    BSF		SERIAL_OUT 			;BIT SET MAKE SERIAL OUT HIGH
        CALL    BIT_DELAY          	;DATA BIT DELAY FOR 2400 BAUD  
        DECFSZ 	BIT_CNTR1,1  		;CHECK TO SEE IT 8 BITS HAVE BEEN SENT
        GOTO	XMIT1               ;GET EIGHT BITS        
        BSF     SERIAL_OUT          ;SET SERIAL OUT HIGH FOR END OF TRANSMISSION
        RETLW	0                   ;RETURN TO START


		  

		END
